#include <pluginlib/class_list_macros.h>
#include <ros/ros.h>

#include "ultrasonic/Ultrasonic.h"

#include "car/ussDataMsg.h"

PLUGINLIB_EXPORT_CLASS(car::Ultrasonic, nodelet::Nodelet
);

namespace car
{

Ultrasonic::Ultrasonic() :
    // USS_SRF02(DEVICE_ADDRESS1),
    messageOStream(nh, "Ultrasonic")
{}

void Ultrasonic::onInit()
{
    messageOStream.write("onInit", "START");

    ussData = nh.advertise<ussDataMsg>("ussData", 1);
    sensorThread = std::thread(
        [this]
        {
            for (;;)
            {
                ussDataMsg msg;
                // auto distance = getDistance();
                float distance = 0.0;
                msg.distance = distance;
                ussData.publish(msg);
            }
        });

    messageOStream.write("onInit", "STOP");
}
}
